include \masm32\include\masm32rt.inc

EolMode	equ 13, 10
; EolMode	equ 32,32,32,32		; for horizontal display

mbDebug MACRO slot:REQ, txt_title:REQ, args:VARARG
 pushad
 pushfd
 ifndef mbDebugbuff
	.data?
	mbDebugbuff	db 2048 dup (?)
	.data
	mbDebugbptr	dd mbDebugbuff
	mbDebugStop	dd 5 dup (IDOK)
	.code
 endif
 push offset mbDebugbuff
 pop mbDebugbptr
 mov byte ptr mbDebugbuff, 0
 for arg, <args>
	LOCAL tmp$, cc
	cc INSTR <arg>, <$>
	pushad
	tmp$ CATSTR <chr$(">, <arg>, <")>
	if cc
		mov mbDebugbptr, cat$(mbDebugbptr, tmp$, chr$(9), <arg>, chr$(EolMode))
	else
		mov mbDebugbptr, cat$(mbDebugbptr, tmp$, chr$(9), sstr$(arg), chr$(EolMode))
	endif
	popad
 ENDM
 .if mbDebugStop+4*slot==IDOK
	invoke MessageBox, 0, addr mbDebugbuff, reparg(txt_title), MB_OKCANCEL
 .endif
 mov mbDebugStop+4*slot, eax
 popfd
 popad
ENDM

  mvalx$ MACRO args:VARARG
    ;; ------------------------------------------------
    ;; macro accepts 6 classes of input
    ;;   1. quoted text
    ;;   2. unsigned value with a leading "*" EG *myval
    ;;   3. signed value
    ;;   4. a line feed using the notation "lf"
    ;;   5. name of a string variable if leading /  eg. /MyStr
    ;;   6. address of a string if leading //  eg. //MyStrAddr
    ;; ------------------------------------------------
      pushad
      pushfd
      IFNDEF @_buff_@
      .data?
        @_buff_@ db 1024 dup (?)
      .data
        @@_bptr_@@ dd @_buff_@
      .code
      ENDIF
        mov eax, OFFSET @_buff_@
        mov DWORD PTR [eax], 0
        for arg, <args>
          char1 SUBSTR <arg>,1,1                                ;; get 1st character
          if @SizeStr(<arg>) GT 1
            char2 SUBSTR <arg>,1,2                              ;; get 1st TWO characters
            char3 SUBSTR <arg>,2
            if @SizeStr(<arg>) GT 2
              char4 substr <arg>,3
            endif
          endif
            IFIDN char1,<">
              mov @@_bptr_@@, cat$(@@_bptr_@@,arg)              ;; add quoted text
              goto label0
            ENDIF
            IFIDN <arg>,<lf>
              mov @@_bptr_@@, cat$(@@_bptr_@@,chr$(13,10))      ;; add line feed
              goto label0
            ENDIF
            IFIDN char1,<*>
              item textequ char3
              mov @@_bptr_@@, cat$(@@_bptr_@@,ustr$(item)," ")  ;; add unsigned arg converted to string
              goto label0
            ENDIF
            if @SizeStr(<arg>) GT 2
                IFIDN char2,<//>
                  item textequ char4
                  mov @@_bptr_@@, cat$(@@_bptr_@@,<item>," ")  ;; was address of a string
                  goto label0
                ENDIF
            endif
            if @SizeStr(<arg>) GT 1
                IFIDN char1,</>
                  item textequ char3
                  mov @@_bptr_@@, cat$(@@_bptr_@@,addr(item)," ")  ;; was name of a string
                  goto label0
                ENDIF
            endif
            mov @@_bptr_@@, cat$(@@_bptr_@@,sstr$(arg)," ")     ;; add signed arg converted to string
        :label0
        ENDM
      popfd
      popad
      mov eax, OFFSET @_buff_@
      EXITM <eax>
    ENDM
.data
q     dd 99
cPos  dd 20
ptxt  dd 0
tSize dd 6
algn  dd 8
lfont dd 10
qtd db 'This is "quoted".',0
MyPath  db "MulDbgMacro.asm", 0
aMyPath dd txMyPath

.code

txMyPath	db "MulDbgMacro.asm", 0
txMyGreets	db 13,10,10, "Thanks to JimG for the ",34,"fine tuning",34," ;-)", 0
MyFilePath$	dd txMyPath
MyGreets$	dd txMyGreets

start:
	mov ptxt, mvalx$("cPos=",cPos,lf,"tSize=",tSize,lf,"lfont=",lfont,lf ,"q = ",q,lf,"algn=",*algn,lf,"quoted=","This is ""quoted"".",lf,"quoted2=",/qtd,lf,"/path = ",/txMyPath,lf,"//path = ",//MyFilePath$)
	print ptxt,13,10

	if 0

	mov ptxt, mvalx$("cPos=",cPos,lf,"tSize=",tSize,lf,"lfont=",lfont,lf ,"q = ",q,lf,"algn=",*algn,lf,"quoted=",\
	"This is ""quoted"".",lf,"quoted2=",/qtd,lf,"/path = ",/txMyPath,lf,"//path = ",//MyFilePath$)
	print ptxt,13,10

	endif

	call main
	exit

main proc
    LOCAL MyCounter:DWORD, My2ndVar:DWORD, MyThirdVar:DWORD
    mov MyCounter, 111
    mov My2ndVar, 222
    mov MyThirdVar, 333
    .While MyCounter>0
	pushad
	mov eax, 1000001
	mov ecx, 1000002
	mov edx, 1000003
	mov esi, 1000004
	mov edi, 1000005
	mov ebx, 1000006
	mbDebug 0, "Show me the registers and five variables:", \
	eax, ecx, edx, esi, edi, ebx, ebp, esp, \
	MyCounter, MyThirdVar, MyFilePath$, MyGreets$
	dec MyCounter
	mbDebug 1, "Show me the vars:", MyCounter, MyThirdVar, MyFilePath$
	popad
    .Endw
    ret

main endp
end start

OPT_DelTmp	0
OPT_Icon	Eye
